#include "t_services.h"
#include "kernel_id.h"
#include "sync_receiver.h"
#include "ad1836a.h"
#include "stk.h"
#include "c408khz.h"

#define LPFTAPS 	206
#define DECIM1TAPS 	31
#define DECIM2TAPS 	63
#define DECIM3TAPS 	127
#define COUNT SAMPLE_PER_INTR 

static short sound[COUNT], 		signal[COUNT*64], sp[COUNT*64];
static short temp_r[COUNT*64],	temp_i[COUNT*4];
static short temp2_r[COUNT*64],	temp2_i[COUNT*4];
static short lo_r[COUNT*64], 	lo_i[COUNT*4];


static short re_coeff[LPFTAPS]={
	#include "lpf_re.txt"
};

static short im_coeff[LPFTAPS]={
	#include "lpf_im.txt"
};

static short decim1_coeff[(DECIM1TAPS+4)*2]={	/* 傫(^bv+fV[V)̔{ */
	#include "decim1.txt"
};

static short decim2_coeff[(DECIM2TAPS+4)*2]={
	#include "decim2.txt"
};

static short decim3_coeff[(DECIM3TAPS+4)*2]={
	#include "decim3.txt"
};

static struct CODEC_BUFFER tx_buf;

	int p2p[100];
	int idx= 1;
	float freq = 454900.0;
	int state = 0;

void modem_task(VP_INT extinf)
{
	struct CODEC_BUFFER * rx_buf;
	
		// fV[^[
	stk::CFilter * decim1 = 	new stk::CDecimator( decim1_coeff, DECIM1TAPS, 4, true );	// 1/4_ETv
	stk::CFilter * decim2 = 	new stk::CDecimator( decim2_coeff, DECIM2TAPS, 4, true );	// 1/4_ETv
	stk::CFilter * re_decim3 = 	new stk::CDecimator( decim3_coeff, DECIM3TAPS, 4, true );	// 1/4_ETv
	stk::CFilter * im_decim3 = 	new stk::CDecimator( decim3_coeff, DECIM3TAPS, 4, false );
		// ̕ftB^
	stk::CFilter * re_lpf = new stk::CFirFilter( re_coeff, LPFTAPS );
	stk::CFilter * im_lpf = new stk::CFirFilter( im_coeff, LPFTAPS );
		// 408KHz̋ǔ@3072KSPS
//	stk::CDDS * lo1 = new stk::CDDS( 570425344 ); // 408KHz = 408/3072*2^32
	C408kHz * lo1 = new C408kHz(); 
		// 47KHz̋ǔ@192KSPS
	stk::CDDS * lo2 = new stk::CDDS( 0x3EAAAAAB ); // 47KHz = 47/192*2^32
		// eXgM
/*
*	eXggɂ:
*	3072KSPSɂď]̎gf(KHz)𓾂ɂ́ACDDSɎgƂ
*	f/3072 * 2^32 ^΂悢B
*/
	stk::CDDS * sg = new stk::CDDS( 636835157 ); // 455.5KHz @ 3072KSPS



	act_tsk( CODEC_TASK );
	while( 1 )
	{
		int sample, slot;
		
		rcv_dtq( CODEC_RX_DTQ, (VP_INT*)& rx_buf );

				// ̓f[^LRoĉZB
				// SLOT 0 : Internal L
				// SLOT 4 : Internal R
				// 24 bit f[^Z, 16bit
				// ۂ߂邽߂17bitVtg
		for ( sample = 0; sample < COUNT; sample++ )
			sound[sample] = ( rx_buf->data[sample][0] + rx_buf->data[sample][4] ) >> 17;
				// sound ɂ̓mf[^ĂB		

				// ---------- WQg -------------
				// QƐM(48KHz cosg)𐶐


	
		sg->run( signal, COUNT*64 );
		stk::mul( signal, signal, 0x2000 , COUNT*64 ); // XP[_E
		
		lo1->run( lo_r, COUNT*64 );
		stk::mul( temp2_r, signal, lo_r, COUNT*64 ); // _ERo[g

      	decim1->run( temp_r, temp2_r, COUNT*64 ); // fV[^[
      	decim2->run( temp2_r, temp_r, COUNT*16 ); // fV[^[
		
				// ---------- USB  -------------
				// fǔ(+47KHz ͐M)𐶐
		lo2->run( lo_r, lo_i, COUNT*4 );
                // -47KHzŃ_ERo[g
    	stk::mul( temp_r, lo_i, temp2_r, COUNT*4 );    // -47Khzɂ邽߂
    	stk::mul( temp_i, lo_r, temp2_r, COUNT*4 );    // sin/cosւ
 
      	re_decim3->run( temp2_r, temp_r, COUNT*4 ); // 
    	im_decim3->run( temp2_i, temp_i, COUNT*4 ); // 
		
      	re_lpf->run( temp_r, temp2_r, COUNT ); // 
    	im_lpf->run( temp_i, temp2_i, COUNT ); // 
 
		stk::sub( sound, temp_r, temp_i, COUNT );    // USB
//	  	stk::add( sound, temp_r, temp_i, COUNT );    // LSB

		for ( sample = 0; sample < COUNT; sample++ )
		{
			tx_buf.data[sample][0] = sound[sample] << 16;//rx_buf->data[sample][0];
			tx_buf.data[sample][4] = sound[sample] << 16;//rx_buf->data[sample][4];
		}
				// ---------- o̓obt@ɃRs[ -------------
		snd_dtq( CODEC_TX_DTQ, (VP_INT) & tx_buf ); 
		
	int min, max;
		
		if ( 0 == state )
		{
			sg->setFreq( (int)(freq*4294967296.0/3072000) );
			state += COUNT;
			min = max = 0;
		}
		else if ( state < 480 )
			state += COUNT;
		else if ( state < 4800 )
		{
			for ( int i = 0; i<COUNT; i++ )
			{
				min = (sound[i] < min )?sound[i]:min;
				max = (sound[i] > max )?sound[i]:max;
			}
			state += COUNT;
		}
		else 
		{
			p2p[idx] = max - min;
			state = 0;
			idx ++;
			freq -= 100;
		}
		if ( idx == 100 )
		{
			idx = 100;	
		}
		
	}
}


