#include "stk.h"
#include "filter.h"
#include <string.h>

	extern "C" void  ddsbody(
			short cos[],		// 
			short sin[],		//  sinsv̂ƂcosƓAhXn
			unsigned int count,	// 
			unsigned int * phase	//  phase͓ʑ(L,H)Ǝg(L,H)4[hȂ
								// ꂼ32bitŁAʑ̏16тƂ\Ɏg
								// Ԃ͉ʂPL,PH,FL,FH
			);
	extern "C" void decimbody( fract16 out[], const fract16 in[], int countBy2R, fir_state_fr16 * s );

namespace stk{	
/*************************** CDDS ************************************/
	void CDDS::run( short cos[], short sin[], unsigned int count )
	{
		ddsbody( cos, sin, count, state );
	}
	
	void CDDS::run( short cos[], unsigned int count )
	{
		ddsbody( cos, cos, count, state );
	}
/*************************** CFilter ************************************/
	CFilter::CFilter(const short coeff[], unsigned int taps, unsigned int index) // FIR WA^bvA/ԈCfbNX.
	{		
		this->s = new fir_state_fr16;
		short * delay = new short[taps];
		
		for ( int i=0; i<taps; i++ )
			delay[i] = 0;
			
		s->h = (fract16 *)coeff;
		s->d = delay;
		s->p = delay;
		s->k = taps;
		s->l = index;
	}

	CFilter::~CFilter()
	{
		delete this->s->d;
		delete this->s;
	}
/*************************** CFirFilter ************************************/
	void CFirFilter::run( short out[], const short in[], unsigned int count )
	{
		fir_fr16(in, out, count, this->s);
	}

/*************************** CDecimator ************************************/
   	CDecimator::CDecimator( const short coeff[], unsigned int taps, unsigned int ratio, bool doReorder )
    			:CFilter::CFilter( coeff, taps+ratio, ratio )
    { 
    	if ( doReorder ) 
    		this->reorder(); 
    }
    
	void CDecimator::reorder( void )
    {
    	short * coeff;
    	int i, j, count, ratio, taps;
    	
    		// CpXoB
    	coeff = this->s->h;
    	ratio = this->s->l;
    	taps = this->s->k-ratio;
    		// ʌ`̃CpXAfir_decima_fr16pɂȂׂȂ
    	i = 0;
		for ( int count = taps-1; count >=0; count-- )
			coeff[count*2+1]=coeff[count];
			
		i = 1;
		j = ratio*2;
		for ( int count = 0; count < taps; count++ ){
			coeff[j] = coeff[ i ];
			j += 2;
			i += 2;
		}
			
		i = 0;
		j = 2 * ( taps + ratio ) -1;
		for ( int count = 0; count < ratio; count++ ){
			coeff[ i ] = coeff[ j ] = 0;
			i += 2;
			j -= 2;
		}
	}

	void CDecimator::run( short out[], const short in[], unsigned int count )
	{
		decimbody(out, in, count/2/this->s->l, this->s);
	}

/*************************** CInterpolator ************************************/
   	CInterpolator::CInterpolator( const short coeff[], unsigned int taps, unsigned int ratio, bool doReorder )
    			:CFilter::CFilter( coeff, taps/ratio, ratio )
    { 
    	if ( doReorder ) 
    		this->reorder(); 
    }

	void CInterpolator::reorder( void )
    {
    	short * temp, * coeff;
    	int i, ratio, taps;
    	
    		// fBCCꎞ̈ƂĎgp
    	temp = this->s->d;
    	coeff = this->s->h;
    	ratio = this->s->l;
    	taps = this->s->k*ratio;
    		// ʌ`̃CpXAfir_decima_fr16pɂȂׂȂ
    	i = 0;
		for ( int np = 0; np < ratio; np++ )
			for ( int nc = 0; nc < taps; nc+= ratio )
				temp[ i++ ] = coeff[ np + nc ];
			// Ɨ̈悩ׂȂʂRs[
		memcpy( coeff, temp, sizeof(short)*taps );
			// ƗpɎgfBCꂢɂ
		for ( int i=0; i<taps; i++ )
			temp[i] = 0;		
	}

	void CInterpolator::run( short out[], const short in[], unsigned int count )
	{
		fir_interp_fr16(in, out, count, this->s);
	}

/*************************** ֐ ************************************/
	void mul( short dst[], short src1[], short src2[], int count )
	{
#ifdef STRICT_OPTIMIZATION
		#pragma no_alias
		#pragma different_banks 
		#pragma loop_count( 4, ,2 )
#endif
 	    for ( int i=0; i<count; i++ )
	        dst[i] = multr_fr1x16( src1[i], src2[i]);          
	        
	}
	
	void mul( short dst[], short src1[], short src2, int count )
	{
#ifdef STRICT_OPTIMIZATION
		#pragma no_alias
		#pragma different_banks 
		#pragma loop_count( 4, ,2 )
#endif
 	    for ( int i=0; i<count; i++ )
	        dst[i] = multr_fr1x16( src1[i], src2);          
	        
	}

	void add( short dst[], short src1[], short src2[], int count )
	{
#ifdef STRICT_OPTIMIZATION
		#pragma no_alias
		#pragma different_banks 
		#pragma loop_count( 4, ,2 )
#endif
 	    for ( int i=0; i<count; i++ )
	        dst[i] = add_fr1x16( src1[i], src2[i]);          
	        
	}
	
	void add( short dst[], short src1[], short src2, int count )
	{
#ifdef STRICT_OPTIMIZATION
		#pragma no_alias
		#pragma different_banks 
		#pragma loop_count( 4, ,2 )
#endif
 	    for ( int i=0; i<count; i++ )
	        dst[i] = add_fr1x16( src1[i], src2);          
	        
	}
	
	void sub( short dst[], short src1[], short src2[], int count )
	{
#ifdef STRICT_OPTIMIZATION
		#pragma no_alias
		#pragma different_banks 
		#pragma loop_count( 4, ,2 )
#endif
 	    for ( int i=0; i<count; i++ )
	        dst[i] = sub_fr1x16( src1[i], src2[i]);          
	        
	}
	
	void sub( short dst[], short src1[], short src2, int count )
	{
#ifdef STRICT_OPTIMIZATION
		#pragma no_alias
		#pragma different_banks 
		#pragma loop_count( 4, ,2 )
#endif
		for ( int i=0; i<count; i++ )
	        dst[i] = sub_fr1x16( src1[i], src2);          
	        
	}

	void sub( short dst[], short src1, short src2[], int count )
	{
#ifdef STRICT_OPTIMIZATION
		#pragma no_alias
		#pragma different_banks 
		#pragma loop_count( 4, ,2 )
#endif
		for ( int i=0; i<count; i++ )
	        dst[i] = sub_fr1x16( src2[i], src1);          
	        
	}
};

