#pragma once
#include <fract.h>
#include <filter.h>
namespace stk{
    class CDDS{
    protected:
        unsigned int state[2];
                        // state[0]:ʑ
                        // state[1]:g
                        // ʑ32bit2΂킷
                        // g1TvƂ̈ʑip킷B
    public:
        CDDS( unsigned int freq ) {state[0] = 0; state[1]= freq;};
        void setFreq( unsigned int freq )  { state[1] = freq;  };  // ʑ̋ύX
        void setPhase( unsigned int phase ){ state[0] = phase; };  // g̋ύX
        virtual void run ( short cos[], short sin[], unsigned int count );     
        virtual void run ( short cos[], unsigned int count );     
    };
    
    class CFilter{
    protected:
    	fir_state_fr16 *s;
    public:
    					// coeff : CpX
    					// taps : ^bv
    					// index : |tF[YXe[W
    	CFilter(const short coeff[], unsigned int taps, unsigned int index); // FIR WA^bvA/ԈCfbNX.
    	virtual ~CFilter();
   		virtual void run ( short out[], const short in[], unsigned int count ) = 0;
    };
    
    class CFirFilter:public CFilter{
    public:
    					// coeff : CpX
    					// taps : ^bv
    	CFirFilter( const short coeff[], unsigned int taps )
    			:CFilter::CFilter( coeff, taps, 1 ){};
    	virtual void  run( short out[], const short in[], unsigned int count );
    };

    class CDecimator:public CFilter{
    private:
    		// coeffׂȂvCx[g֐
    	virtual void reorder( void );
    public:
    					// coeff : CpXB
    					// taps : ^bvB ratio̐{
    					// ratio :I[o[Tv
    					// doReorder : 1̂ƂAcoeff̏f[^^ɂ킹ĕׂȂB
    					//             0̂ƂAcoeff fir_interp_fr16̌Wɏ]Ɖ
    					// coeff̃TCYɒӁBcoeff̗vf2(taps+ratio)łȂ΂ȂȂB
    					// doReorder == 1Ȃ΁Acoeff̐擪tapsvfɃCpX
    					// ΂BAcoeff͕pɂĕтB
    	CDecimator( const short coeff[], unsigned int taps, unsigned int ratio, bool doReorder );
    	virtual void  run( short out[], const short in[], unsigned int count );
    };
    
    class CInterpolator:public CFilter{
    private:
    		// coeffׂȂvCx[g֐
    	virtual void reorder( void );
    public:
    					// coeff : CpXB
    					// taps : ^bvB ratio̐{
    					// ratio :I[o[Tv E|tF[YXe[W
    					// doReorder : 1̂ƂAcoeff̏f[^^ɂ킹ĕׂȂB
    					//             0̂ƂAcoeff fir_interp_fr16̌Wɏ]Ɖ
    	CInterpolator( const short coeff[], unsigned int taps, unsigned int ratio, bool doReorder = 0 );
    	virtual void  run( short out[], const short in[], unsigned int count );
    };
    
	void mul( short dst[], short src1[], short src2[], int count );
	void mul( short dst[], short src1[], short src2, int count );
	void add( short dst[], short src1[], short src2[], int count );
	void add( short dst[], short src1[], short src2, int count );
	void sub( short dst[], short src1[], short src2[], int count );	// src1 - src2
	void sub( short dst[], short src1[], short src2, int count ); 	// src1 - src2
	void sub( short dst[], short src1, short src2[], int count ); 	// src1 - src2
}; /* stk */

